#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gnome-hal.h"


	// megahal_initial_greeting();
	// megahal_command("Hello");

	// megahal_cleanup();


void
on_entry1_activate                     (GtkEntry        *entry,
                                        gpointer         user_data)
{
	gchar *input;
 	GtkTextBuffer *txtbuf;
	GtkWidget *textview = lookup_widget(GTK_WIDGET(entry),"textview1");

	megahal_setnoprompt();
	megahal_setnowrap();
	megahal_setnobanner();
	megahal_initialize();

	input = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, 512);

 	// char *buffer = g_strconcat("Interpreting '", input, "'", NULL);

	char *buffer = megahal_do_reply(input, 0);

 	long length = strlen(buffer);
 	txtbuf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));
 	gtk_text_buffer_set_text(txtbuf, buffer, length);
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *input;
 	GtkTextBuffer *txtbuf;
	GtkWidget *textview = lookup_widget(GTK_WIDGET(button),"textview1");
	GtkWidget *entry = lookup_widget(GTK_WIDGET(button),"entry1");

	megahal_setnoprompt();
	megahal_setnowrap();
	megahal_setnobanner();
	megahal_initialize();

	input = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, 512);

 	// char *buffer = g_strconcat("Interpreting '", input, "'", NULL);

	char *buffer = megahal_do_reply(input, 0);

 	long length = strlen(buffer);
 	txtbuf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));
 	gtk_text_buffer_set_text(txtbuf, buffer, length);
}


void
on_quitbutton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
}

